package Storage;
use strict;
use Mysql;

BEGIN{
    require Exporter;
    use vars qw(@ISA @EXPORT $VERSION);
    $VERSION=0;
    @ISA = qw(Exporter);
    @EXPORT = qw( &newStorage &insert );
}

sub newStorage {
    my $s = shift;
    my $self={};
# Connect to database
    $self->{dbh} = Mysql->connect(
				  $s->{SQLserver},
				  $s->{SQLdatabase},
				  $s->{SQLuser},
				  $s->{SQLpassword}
				  )
	|| die $!;
# Compute identifier
    my $sth=($self->{dbh})->query(
      "SELECT identifier FROM NetworkVerbosePing")
	or die $!;
    my @idxs = sort { $a <=> $b } ($sth->fetchcol(0));
    foreach ( @idxs ) { 
	print "."; 
    }

    my $id=0;
    while ( (defined $idxs[$id]) && ($idxs[$id]== $id) ) { $id++; }
    $self->{identifier}=$id;
    print "$id\n";
# Create new row in record database
    my $values ="'$s->{probeIP}', '$s->{targetIP}', 'jameter', $s->{version}, 
	 $s->{port}, $s->{period}, $s->{length}, $s->{scale}, $id"; 
    my $query="INSERT INTO NetworkVerbosePing Values( $values )";
    ($self->{dbh})->query($query)
	or die "INSERT error";

    bless $self;
    return $self;
}

sub insert {
    my ( $self, $time, $usec, $sendFwd, $diffFwd, $diffLat, $diffBwd ) = @_;
    my $id=$self->{identifier};

    sub a {
	my ( $D,$t,$i,$j ) = @_;
	return ($D->[$j] - $D->[$i])/($t->[$j] - $t->[$i]);
    }
    

# Insert new row
    my $values ="$id, FROM_UNIXTIME($time), $usec, $sendFwd, $diffFwd, \"\", $diffLat, $diffBwd, \"\""; 
#    print "$values\n";
    my $query="INSERT INTO NetworkVerbosePingData Values( $values )";
    ($self->{dbh})->query($query)
	or die $!;
    
 FWD: {
# Update potential minimum tags for Fwd delays...
# Find all rows tagged as potential minimum
     my $sth=($self->{dbh})->query(
       "SELECT UNIX_TIMESTAMP(timestamp),sendFwd,diffFwd 
       FROM NetworkVerbosePingData 
       WHERE identifier=$id && pmdFwd is not NULL")
	 || die $!;
     my $t=$sth->fetchall_arrayref
	 or die "$sth $!";
# Scan rows and untag unacceptable minima 
# (see algorithm and proof in paper)
     my $n=$#{$t};
     ( $n > 1 ) || return;
     my @m=sort { $a->[0] <=> $b->[0] } @$t;
     my $p;
     for ($p=$n-1; $p>0; $p--) {
	 if ( 
	      ($t->[$p][2] - $t->[$p-1][2])/($t->[$p][0] - $t->[$p-1][0]) >=
	      ($t->[$n]  [2] - $t->[$p] [2])/($t->[$n]  [0] - $t->[$p] [0]) 
	      ) {
# Untag query
	     $sth=($self->{dbh})->query(
		"UPDATE NetworkVerbosePingData SET pmdFwd=NULL
                WHERE timestamp=FROM_UNIXTIME(\"$t->[$p][0]\")")
		 || die $!;
	 } else {
	     last;
	 }
     }
 }
    
 BWD: {
# Find all rows tagged as potential minimum
     my $sth=($self->{dbh})->query(
       "SELECT UNIX_TIMESTAMP(timestamp),sendFwd,diffBwd 
       FROM NetworkVerbosePingData 
       WHERE identifier=$id && pmdBwd is not NULL")
	 || die $!;
     my $t=$sth->fetchall_arrayref
	 or die "$sth $!";
# Scan rows and untag unacceptable minima 
# (see algorithm and proof in paper)
     my $n=$#{$t};
     my @m=sort { $a->[0] <=> $b->[0] } @$t;
     my $p;
     for ($p=$n-1; $p>0; $p--) {
	 if ( 
	      ($t->[$p][2] - $t->[$p-1][2])/($t->[$p][0] - $t->[$p-1][0]) >=
	      ($t->[$n]  [2] - $t->[$p] [2])/($t->[$n]  [0] - $t->[$p] [0]) 
	      ) {
# Untag query
	     $sth=($self->{dbh})->query(
		"UPDATE NetworkVerbosePingData SET pmdBwd=NULL
                WHERE timestamp=FROM_UNIXTIME(\"$t->[$p][0]\")")
		|| die $!;
	 } else {
	     last;
	 }
     }
 }
}

1;














